package INSTALL::conditional;

sub boolean_value {
  my ($value) = @_;

  if (($value =~ /^yes$/i) ||
      ($value =~ /^true$/i) ||
      ($value =~ /^y$/i) ||
      (($value =~ /[0-9]/) && (int($value) != 0))) 
  {
    return(1);
  }
  elsif ((not $value) ||
	 ($value =~ /^no$/i) ||
	 ($value =~ /^false$/i) ||
	 ($value =~ /^n$/i) ||
	 (($value =~ /[0-9]/) && (int($value) == 0)))
  {
    return(0);
  }
  else {
    return(-1);
  }
}

sub file_exists
{
  ($#_ == 0) || die "Invalid number of arguments.";

  my ($filename) = @_;

  return(-f $filename);
}

sub executable_exists
{
  ($#_ == 0) || die "Invalid number of arguments.";

  my ($filename) = @_;

  return(-x $filename);
}

sub directory_exists
{
  ($#_ == 0) || die "Invalid number of arguments.";

  my ($filename) = @_;

  return(-d $filename);
}

1;
