# This package is responsible for maintaining a list of global variables,
# which are shared among all executing packages. Basically, by default, 
# this consists of maintaining a centralized hash, named variables, and
# allowing users to add and delete from this hash.

package INSTALL::global;
%variables;

sub delete
{
  map { delete $variables{$_} } @_;
  return(1);
}

sub append
{
  my %hash = @_;
  my @keys = keys %hash;

  map { $variables{$_} = $hash{$_} } @keys;

  return(1);
}

1;
