<%	Option Explicit
	Response.Buffer=TRUE

	Dim objFactory				' Chili!Bean Object
	Dim objAddressBook			' AddressBook Object
	Dim refFlag					' To evaluate, or not to evaluate
	Dim BadFlag					' Something does not pass evaluation
	Dim errMsg					' Evaluation Error Message
	Dim Name					' Name from Form
	Dim Address					' Address from Form
	Dim PhoneNumber				' Phone Number from Form
	Dim objEntry				' AddressBook Entry Object
	Dim objEntries				' AddressBook Entries Object
	Dim iBound					' Array Count Variable
	Dim j						' Counter for iterating through Array

	Set objFactory=Session("objFactory")			' Chili!Bean Object (stored in Session)
	Set objAddressBook = Session("objAddressBook")	' Bean-wrapped AddressBook Object (stored in Session)

	Name=Request.Form("Name")
	Address=Request.Form("Address")
	PhoneNumber=Request.Form("PhoneNumber")

'****************************************************************************************
' Purpose:		Verifies/validates user input from Form.
'				If input passes muster, an Entry is created in the AddressBook.
'
' Assumes:		Chili!Bean Object exists as objFactory 
'				AddressBook Object (wrapped in Bean) exists as objAddressBook.
'				Request.Form("Name"),("Address")("PhoneNumber") exist.
'
' Inputs:		None
'
' Returns:		BadFlag:	Includes names of field(s) that do not pass validation (if any)
'				ErrMsg:	Message to be displayed in Form if validation fails (if any)
'
'****************************************************************************************

	Private Sub Submit()

		Dim objVerifier		' AddressBook Verifier Object

		BadFlag=""

		If Name="" then												' If Name is blank...
			BadFlag="Name"											' Add Name to BadFlag
			errMsg="<br><strong>Please enter a name.</strong>"	' Create Name Error Message
			Exit Sub													' Exit Subroutine
		End If

		If PhoneNumber="" then													' If PhoneNumber is blank...
			BadFlag="PhoneNumber"												' Add PhoneNumber to BadFlag
			errMsg="<br><strong>Please enter a phone number.</strong>"		' Create Phone Number Error Message
			Exit Sub																' Exit Subroutine
		End If

		Set objVerifier=objFactory.Construct("AddressBook/PhoneNumberVerifier", PhoneNumber)	' Create PhoneNumberVerifier Object, validate PhoneNumber
	    If Not objVerifier.Verify Then																	' If it fails...
			BadFlag="PhoneNumber"																		' Add PhoneNumber to BadFlag
			errMsg="<br><strong>Please enter a valid phone number.</strong>"						' Create Phone Number Error Message
			PhoneNumber=""																				' Reset Phone Number so errant data is not displayed
			Exit Sub																						' Exit Subroutine
    	End If

		' If we have gotten this far, we have passed all validation
		' Create AddressBook/Entry Object, pass Name/Address/PhoneNumber to it
		Set objEntry = objFactory.Construct("AddressBook/Entry", Name, Address, PhoneNumber)

		objAddressBook.insertEntry objEntry	' Use insertEntry Method to add record to AddressBook

		Name=""			'Reset all variables to nothing
		Address=""
		PhoneNumber=""

	End Sub


	If Request.Form("refFlag")="abandon" then		' If user has hit Reset AddressBook Button

		Session.Abandon												' Destroy Bean, AddressBook on Re-direct
		Response.Redirect "AddressBook.asp"			' Re-direct to self (starts new Session)
	End If

	If Request.Form("refFlag")="Y" then Submit		' If user hit Submit Button, then call Submit Subroutine

%>
<html>

<head>
<title>Chili!Beans Address Book Demonstration</title>
</head>

<body bgcolor="#FFFFFF" text="#000000" link="#CC0000" vlink="#CC0000" alink="#CC0000" topmargin="0" marginheight="0" leftmargin="4" marginwidth="4">
<div align="center"><center>

<table border="0" width="721" cellpadding="5">
  <tr>
    <td width="33%"><a href="viewsrc.asp"><font face="Arial" size="2"><strong>View Source
    Files</strong></font></a><p><a href="default2.asp"><font face="Arial" size="2"><strong>Read
    Explanation</strong></font></a></td>
    <td width="33%" valign="top"><p align="center"><img src="images/whitebeans.anim.gif" alt="Chili!Beans" WIDTH="224" HEIGHT="47"></td>
    <td width="33%" valign="top"><p align="right"><a href="http://www.chilisoft.com"><img src="images/cslogonewcolorsm.gif" alt="cslogonewcolorsm.gif (2381 bytes)" border="0" WIDTH="112" HEIGHT="55"></a></td>
  </tr>
</table>
</center></div><div align="center"><center>

<table border="1" bordercolor="#CC0000" cellspacing="0" cellpadding="2" bordercolorlight="#CC0000" bordercolordark="#CC0000">
  <tr>
    <td valign="top" width="200"><div align="center"><center><table border="1" cellspacing="0" cellpadding="2" bordercolor="#000000" bordercolorlight="#000000" bordercolordark="#000000">
      <tr>
        <td bgcolor="#C0C0C0" height="10"><p align="left"><font face="Arial" size="2" color="#000000"><strong>Address Book Entry:</strong></font></td>
      </tr>
      <tr>
        <td bgcolor="#000000" height="160"><form method="POST" action="addressbook.asp">
          <input type="hidden" name="refFlag" value="Y"><table cellspacing="0" cellpadding="2" border="0" width="100%">
            <tr>
              <td bgcolor="#000000" height="35" valign="middle"><strong><strong><font face="Arial" size="2" color="#FFFFFF"><% If Instr(BadFlag,"Name") then %> <font color="#CC0000"><% End If %>Name:</font></font></strong></strong></td>
              <td bgcolor="#000000" height="35" valign="middle"><font face="Arial" size="2"><input type="text" name="Name" value="<%=Name%>" size="20" maxlength="50"></font></td>
            </tr>
            <tr>
              <td bgcolor="#000000" height="35" valign="middle"><font face="Arial" size="2" color="#FFFFFF"><strong>Address:</strong></font></td>
              <td bgcolor="#000000" height="35" valign="middle"><font face="Arial" size="2"><input type="text" name="Address" value="<%=Address%>" size="20" maxlength="50"></font></td>
            </tr>
            <tr>
              <td bgcolor="#000000" height="35" valign="middle"><font face="Arial" size="2" color="#FFFFFF"><strong><% If Instr(BadFlag,"PhoneNumber") then %> <font color="#CC0000"><% End If %>Phone<br>
              Number:</font></strong></font></td>
              <td bgcolor="#000000" height="35" valign="middle"><font face="Arial" size="2"><input type="text" name="PhoneNumber" value="<%=PhoneNumber%>" size="20" maxlength="20"></font></td>
            </tr>
            <tr>
              <td bgcolor="#000000" colspan="2" valign="middle" align="center" height="0"><div align="center"><center><p><font face="Arial" size="2"><input type="submit" value="Submit" name="B1"></font></td>
            </tr>
          </table>
        </form>
        </td>
      </tr>
      <tr align="center">
        <td bgcolor="#FFFFFF" valign="middle" align="center" height="140"><% If BadFlag<>"" then %>
<div align="center"><center><table border="0" cellspacing="0" cellpadding="5">
          <tr>
            <td bgcolor="#000000"><p align="center"><img src="images/arrow.gif" alt="arrow.gif (1199 bytes)" WIDTH="15" HEIGHT="35"><br>
            <font face="Arial" size="3" color="#FF0000"><strong>E<br>
            r<br>
            r<br>
            o<br>
            r</strong></font></td>
            <td bgcolor="#C0C0C0"><% If Instr(BadFlag,"Name") then %>
<p align="center"><strong><font face="Arial" size="2">You didn't
            enter a name.<br>
            <font color="#CC0000">Name</font> is required.</font></strong></p>
            <p><strong><font face="Arial" size="2"><% End If%><% If Instr(BadFlag,"PhoneNumber") then %> </font></strong></p>
            <p align="center"><strong><font face="Arial" size="2">You didn't enter a valid<br>
            Phone Number.<font color="#CC0000"><br>
            Phone Number</font> is required.<br>
            Ex. 1-xxx-yyy-zzzz <% End If%></font></strong></td>
          </tr>
        </table>
        </center></div><% Else %>
<p>&nbsp;<% End If %> </td>
      </tr>
      <tr align="center">
        <td bgcolor="#FFFFFF" valign="bottom" align="center" height="20"><font face="Arial" size="2"><form method="POST" action="addressbook.asp">
          <input type="hidden" name="refFlag" value="abandon"><div align="center"><center><p><font face="Arial" size="2"><input type="Submit" value="Reset Address Book" name="B2"></font></font></p>
          </center></div>
        </form>
        </td>
      </tr>
    </table>
    </center></div></td>
    <td valign="top" align="center" width="521"><table border="1" cellspacing="0" cellpadding="3" width="100%" bordercolor="#000000" bordercolorlight="#000000" bordercolordark="#000000">
      <tr>
        <td colspan="3" bgcolor="#000000"><p align="center"><font face="Arial" size="3" color="#FFFFFF"><strong>Address Book Contents</strong></font></td>
      </tr>
<%		objAddressBook.Reset					' Reset Address Book (movefirst)
		If objAddressBook.hasRecords Then	' If any records, then write them out to the table

%>
      <tr>
        <td><font face="Arial" size="2" color="#000000"><strong>Name:</strong></font></td>
        <td bgcolor="#FFFFFF" nowrap><font face="Arial" size="2" color="#000000"><strong>Address:</strong></font></td>
        <td bgcolor="#FFFFFF" nowrap><font face="Arial" size="2" color="#000000"><strong>Phone
        Number:</strong></font></td>
      </tr>
<%
			objEntries=objAddressBook.getEntries	' Load AddressBook Entries
			iBound=UBound(objEntries)				' Get number of rows in objEntries array
			For j=0 to iBound							' Iterate through rows, write out fields
				Set objEntry=objEntries(j)
%>
      <tr>
        <td><font face="Arial" size="2" color="#000000"><%=objEntry.getName%>&nbsp;</font></td>
        <td bgcolor="#FFFFFF"><font face="Arial" size="2" color="#000000"><%=objEntry.getAddress%>&nbsp;</font></td>
        <td bgcolor="#FFFFFF" nowrap><font face="Arial" size="2" color="#000000"><%=objEntry.getPhoneNumber%></font></td>
      </tr>
<%
			Next
%>
<%
		Else	'If AddressBook is empty
%>
      <tr>
        <td colspan="3" align="center"><p align="center"><font face="Arial" size="2" color="#0000FF"><strong>&nbsp;<br>
        Address Book has no current entries.<br>
        &nbsp;</strong></font></td>
      </tr>
<%
	End If
	If BadFlag<>"" then
%>
      <tr>
        <td colspan="3" align="left" valign="bottom"><p align="center"><img src="images/talkingbean.anim.gif" alt="Uh, Texarkana, we have a problem..." WIDTH="100" HEIGHT="200"></td>
      </tr>
<% Else %>
      <tr>
        <td colspan="3" align="center" valign="bottom"><img src="images/smallbeans.anim.gif" alt="I am Chili!Bean..." WIDTH="100" HEIGHT="200"></td>
      </tr>
<% End If %>
    </table>
    </td>
  </tr>
</table>
</center></div>
</body>
</html>
