//AddressBook.java

package AddressBook;

class AddressBook extends DatabaseBase.Table implements java.io.Serializable
{
	public AddressBook()
	{
		super();
	}

		//add record at end of table
	public synchronized void addEntry(Entry r)
	{
		addRecord(r);

	}

	public synchronized void insertEntry(Entry r)
	{
		//want to insert / edit according to whether name
		//already exists in table
		if (!hasRecords())
		{
			addRecord(r);
			return;
		}

		reset();
		
		String name = r.getName().toUpperCase();
		while (true)
		{
			String currentname = getEntry().getName().toUpperCase();
			int iCompare = name.compareTo(currentname);
			if (iCompare == 0)
			{
				//duplicate key.  just replace old entry with this one
				replaceRecord(r);
				return;
			}
			else if (iCompare < 0)
			{

				//insert this string at current posiion
				insertRecord(r);
				return;
			}
			else
			{
				//string added is still bigger than current one. Keep going
			}

			if (EOF())
			{
				addRecord(r);
				return;
			}

			moveNext();
		}
		
	}

	//get record at current position
	public synchronized Entry getEntry()
	{
		return (Entry)getRecord();
	}

	public synchronized Entry[] getEntries()
	{
		DatabaseBase.Record[] records = getRecords();
		if (records == null)
		{
			return null;
		}

		int iCount = records.length;
		Entry[] entries = new Entry[iCount];

		for (int i = 0; i < iCount; i++)
		{
			entries[i] = (Entry)records[i];
		}

		return entries;
	}

}

