<%
	'
	' This page contains two Calendar subroutines.
	'
	' The first does the graphical work, given which day
	' of the week to start on, how many days in the month,
	' and (optional) formats for the (assumed) table entries.
	'
	' The second lets you give it a month and year and then
	' figures out the starting day of week and number of days
	' in the given month.  It then calls the first subroutine.
	'
	' You could easily wrap both of these in an outer subroutine
	' that does all the work done on this page (that is, one
	' that also prints the month and year at top of the calendar
	' and otherwise formats the TABLE that is used.
	'
	' Flexibility was the primary aim here, so you can format
	' table cells pretty much the way you want them if you
	' choose to specify the cellStart and cellEnd values.
	'
	' Have fun!
%>

<%
	Sub HTML( msg )
		Response.Write msg 
	End Sub
%>

<%
	' Create a calendar that starts on given day of week
	' "start" is 1 for Sunday through 7 for Saturday
	'
	' This Sub assumes that the caller has already set up
	' a TABLE with appropriate pretty controls
	'
	Sub BaseCalendar( startDay, daysInMonth, cellStart, cellEnd )
	    ' Give reasonable defaults for cellStart and cellEnd
		' if either is not provided by caller:
		If ( (cellStart="") Or ( cellEnd="") ) Then
			cellStart = "<TD Align=Center BGColor=lightgreen><Font size=6><B>"
			cellWeekend = "<TD Align=Center BGColor=pink><Font size=6><B>"
			cellEnd = "</B></FONT></TD>"
		Else
			cellWeekend = cellStart
		End If
		'
		Dim day, curdate
		curdate = 2 - startDay	' sneaky! figure it out!
		Do While curdate <= daysInMonth 
			HTML "    <TR>" & vbCrLf
			For wd = 1 to 7 
				If (curdate > 0) And (curdate <= daysInMonth) Then
					If (wd = 1) Or (wd = 7) Then
						HTML "        " & cellWeekend & curdate & cellEnd & vbCrLf
					Else
						HTML "        " & cellStart & curdate & cellEnd & vbCrLf
					End If
				Else 
					HTML "        <TD>&nbsp;</TD>" & vbCrLf
				End If
				curdate = curdate + 1
			Next 
			HTML "    </TR>" & vbCrLf
		Loop
		'
	End Sub
%>

<%
	' Create a calendar for a given month in a given year.
	'
	Sub Calendar( themonth, theyear, cellStart, cellEnd )
		' I think VBScript should be able to handle this
		' without the CInt calls here, but it can't.
		'
	    themonth = CInt(themonth)
		theyear  = CInt(theyear)
		'
		dim firstDate, firstDay, daysInMonth
		' firstDate is first day of given month and year
		firstDate = CDate( themonth & "/1/" & theyear )
		' what day does that fall on?
		firstDay = Weekday( firstDate )
		'
		' figure out number of days in the month
		'
		If ( themonth = 2 ) Then
			' February -- assume 28 day month
			daysInMonth = 28
			' But then see if should be 29 day
			If theyear = ( 4 * Int( theyear / 4 ) ) Then
				daysInMonth = 29
				' Every 4 years is a leap year...EXCEPT
				If theyear = ( 100 * Int( theyear / 100 ) ) Then
					daysInMonth = 28
					' Every 100 years is NOT a leap year...EXCEPT
					If theyear = ( 400 * Int( theyear / 400 ) ) Then
						' Every 400 years IS a leap year
						daysInMonth = 29
					End If
				End If
			End If
		Else
			If ( themonth=4 or themonth=6 or themonth=9 or themonth=11 ) Then
				daysInMonth = 30
			Else
				daysInMonth = 31 
			End If
		End If
		' Do the graphical part in base subroutine
		'
		BaseCalendar firstDay, daysInMonth, cellStart, cellEnd
		'
	End Sub
%>

<%
	' MAINLINE ASP code
	'
	chosenMonth = Request("whichMonth")
	chosenYear  = Request("whichYear") 
	if ( NOT IsNumeric(chosenMonth) ) Then chosenMonth = 0
	chosenMonth = CInt(chosenMonth)
	if ( NOT IsNumeric(chosenYear) ) Then chosenYear = 0
	chosenYear = CInt(chosenYear)
	'
	if ( chosenMonth < 1 OR chosenMonth > 12 ) then
		chosenMonth = Month( Date )
		chosenYear  = Year( Date )
	end if
	if ( chosenYear < 1000 Or chosenYear > 9999 ) then
		chosenYear = Year( Date )
	end if
	monthTitle = MonthName(chosenMonth) & " " & chosenYear
%>

<HTML>
<BODY BGCOLOR=white>

<CENTER>
<TABLE border=5 cellPadding=5 cellSpacing=2>
	<TR>
		<TD ColSpan=7 Align=Center>
			<FONT size="+6">
			<B><% = monthTitle %></B>
			</FONT>
		</TD>
	</TR>
	<TR>
		<!-- by using width=12%, the table is 84% of screen width -->
		<TD Align=Center Width="12%">Sunday</TD>
		<TD Align=Center Width="12%">Monday</TD>
		<TD Align=Center Width="12%">Tuesday</TD>
		<TD Align=Center Width="12%">Wednesday</TD>
		<TD Align=Center Width="12%">Thursday</TD>
		<TD Align=Center Width="12%">Friday</TD>
		<TD Align=Center Width="12%">Saturday</TD>
	</TR>
<%
		cellStart = "<TD Align=Right><FONT size=6><I>"
		cellEnd = "<br><br><br></I></FONT></TD>"
		' comment out ONE of two "Calendar" lines that follow for demo
		' pretty, with colors
			Calendar chosenMonth, chosenYear, "", ""
		' if printed, room to write in daily boxes
		'	Calendar chosenMonth, chosenYear, cellStart, cellEnd
%>

</TABLE>
</CENTER>

<CENTER>
<p><p>
If you would like another calendar, enter the month and year below:
<p>

<FORM Action="calendar.asp" Method=POST>
<TABLE border=2 cellPadding=2 cellSpacing=2>
	<TR>
		<TD Align=Right>Month:</TD>
		<TD><SELECT NAME="whichMonth">
<%
			For mo = 1 to 12
				if mo = chosenMonth then
					HTML "			<OPTION SELECTED"
				else
					HTML "			<OPTION"
				end if
				HTML " Value=""" & mo & """>" & MonthName(mo) & vbCrLf
			Next
%>
		</SELECT>
		</TD>
	<TR>
		<TD Align=Right>Year:</TD>
		<TD><INPUT TYPE=Text NAME="whichYear" VALUE="<% = chosenYear %>"></TD>
	</TR>
	<TR>
		<TD Align=Center ColSpan=2>
			<INPUT TYPE=Submit VALUE="New Calendar">
		</TD>
	</TR>
</TABLE>
</FORM>

</CENTER>

<!--#include file="srcform.inc"-->

</BODY>
</HTML>

