//
//
// PolicyItem
//
//

import java.awt.*;
import java.util.*;

public class PolicyItem extends DisplayItem
{
	public String m_type;
	public Date m_effective;
	public Date m_expires;

	protected static Font s_fontLink = null;

	public PolicyItem( Container parent, String number, String type, 
		Date eff, Date exp, Color color, String url, String caption )
	{
		super( parent, 0, true, color, number, url, caption );
		m_type = type;
		m_effective = eff;
		m_expires = exp;
	}

	public void draw( Graphics g, int yPos, int[] columns, Color clrBg )
	{
		// figure the indent and draw the optional p/m....
		super.draw( g, yPos, columns, clrBg );

		FontMetrics fm = g.getFontMetrics();
		// get the width of a "typical" date string....
		int dateWidth = fm.stringWidth("19/29/99");
		
		int xPos = columns[0] + columns[1];
		g.drawString( m_type, 
			xPos - (fm.stringWidth(m_type) + (columns[1] - fm.stringWidth("XXXX"))/2), 
			m_baseline );

		String strDate = DtS(m_effective);
		xPos += columns[2];
		g.drawString( strDate, 
			xPos - (fm.stringWidth(strDate) + (columns[2] - dateWidth)/2), 
			m_baseline );
		strDate = DtS(m_expires);
		xPos += columns[3]; 
		g.drawString( strDate, 
			xPos - (fm.stringWidth(strDate) + (columns[3] - dateWidth)/2), 
			m_baseline );
	}

	String DtS( Date date )
	{
		if ( date != null )
		{
			String str = Integer.toString(date.getMonth()+1) +
				"/" + Integer.toString(date.getDate()) +
				"/" + Integer.toString(date.getYear());
			return str;
		}
		return "";
	}
}

