import DisplayItem;
import java.awt.*;

//
//
// TextItem
//
//
public class TextItem extends DisplayItem
{
	protected boolean m_approved;

	public TextItem( Container parent, int level, String name, 
		boolean approved, Color color, 
		String url, String caption )
	{
		super( parent, level, false, color, name, url, caption );
		m_approved = approved;
	}

	public void draw( Graphics g, int yPos, int[] columns, Color clrBg )
	{
		// figure the indent and draw the optional p/m....
		boolean oldSelected = m_selected;
		if ( !m_approved )
			m_selected = true;
		super.draw( g, yPos, columns, clrBg );
		m_selected = oldSelected;

		if ( !m_approved )
		{
			Color oldColor = null;
			if ( m_color != null )
			{
				oldColor = g.getColor();
				g.setColor( m_color );
			}
			g.drawString( "(Pending)", m_rectLink.x + m_rectLink.width + 10, m_baseline );
			if ( oldColor != null )
				g.setColor( oldColor );
		}
	}
}

