// AmSch.h : Declaration of the CAmSch

#ifndef __AMSCH_H_
#define __AMSCH_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions

/////////////////////////////////////////////////////////////////////////////
// CAmSch
class ATL_NO_VTABLE CAmSch : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAmSch, &CLSID_AmSch>,
	public ISupportErrorInfo,
	public IDispatchImpl<IAmSch, &IID_IAmSch, &LIBID_CALCLib>
{
public:
	CAmSch()
	{ 
		m_bOnStartPageCalled = FALSE;
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_AMSCH)

BEGIN_COM_MAP(CAmSch)
	COM_INTERFACE_ENTRY(IAmSch)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAmSch
public:
	STDMETHOD(put_TableFormat)(/*[in]*/ BSTR newVal);
	STDMETHOD(put_CellFormat)(/*[in]*/ BSTR newVal);
	STDMETHOD(put_InitialAmount)(/*[in]*/ long newVal);
	STDMETHOD(put_InterestRate)(/*[in]*/ long newVal);
	STDMETHOD(put_LengthInYears)(/*[in]*/ long newVal);
	STDMETHOD(Calculate)();
	//Active Server Pages Methods
	STDMETHOD(OnStartPage)(IUnknown* IUnk);
	STDMETHOD(OnEndPage)();

private:
	CComPtr<IResponse> m_piResponse;				//Response Object
	BOOL m_bOnStartPageCalled;						//OnStartPage successful?

	double		m_lAmount;
	double		m_lRate;
	double		m_lLength;
	CString		m_strCell;
	CString		m_strTable;

};

#endif //__AMSCH_H_
