## setup.sh
## 
## updated: 11/18/99
##
##
## CSHOME		- install directory
## CSOS			- os string
## CSTARGET		- debug or release
## CSLIB		- path to lib files
## CSBIN		- path to bin files
## CSREGISTRY	- path to registry directory (optional) 



## this is the install directory
## this is the only variable which needs to be
## manually set
INSTALL_DIR_DEFAULT="[INSTALLPATH]"



## check install dir
if [ -z "$INSTALL_DIR" ];
then
	if [ -z "$1"];
	then
		INSTALL_DIR=$INSTALL_DIR_DEFAULT
	else
		INSTALL_DIR=$1
	fi
fi
unset INSTALL_DIR_DEFAULT

## create os string
OS_VERSION=`uname -r`
OS_MAJOR_VERSION=`echo $OS_VERSION | sed 's/\..*//g'`
OS_NAME=`uname -s`
CSOS=`echo $OS_NAME$OS_MAJOR_VERSION | tr [A-Z] [a-z]`
unset OS_VERSION OS_MAJOR_VERSION OS_NAME

## figure out target
DEFAULT_TARGET=optimized
if [ -z "$CSTARGET" ];
then
	CSTARGET=$DEFAULT_TARGET
else
	if [ "$CSTARGET" != "debug" ];
	then
		if [ "$CSTARGET" != "optimized" ];
		then
			CSTARGET=$DEFAULT_TARGET
		fi
	fi
fi
unset DEFAULT_TARGET


## create paths
CSHOME=$INSTALL_DIR
CSBIN=${CSHOME}/bin/${CSOS}_${CSTARGET}
CSLIB=${CSHOME}/lib/${CSOS}_${CSTARGET}
CSLIB_TOP=${CSHOME}/lib
CSBIN_TOP=${CSHOME}/bin

## create LD_LIBRARY_PATH
if [ -z "$LD_LIBRARY_PATH" ];
then
    LD_LIBRARY_PATH=$CSLIB_TOP:$CSLIB
    export LD_LIBRARY_PATH
else
    CSLIB_DEBUG=$CSLIB_TOP:${CSHOME}/lib/${CSOS}_debug
    CSLIB_OPTIMIZED=$CSLIB_TOP:${CSHOME}/lib/${CSOS}_optimized

    LIB_TEMP=$LD_LIBRARY_PATH
    LIB_ALREADY=`echo $LD_LIBRARY_PATH|egrep '($CSLIB_DEBUG|$CSLIB_OPTIMIZED)'`
    if [ -z "$LIB_ALREADY" ];
    then
        LIB_TEMP=$CSLIB:$LIB_TEMP
    else
	LIB_TEMP=`echo $LIB_TEMP | sed "s,$CSLIB_DEBUG,$CSLIB,g" | sed "s,$CSLIB_OPTIMIZED,$CSLIB,g"`
    fi
    LD_LIBRARY_PATH=$CSLIB_TOP:$LIB_TEMP
    export LD_LIBRARY_PATH
    unset LIB_TEMP LIB_ALREADY CSLIB_DEBUG CSLIB_OPTIMIZED CSLIB_TOP
fi


## create PATH
if [ -z "$PATH" ];
then
    PATH=$CSBIN_TOP:$CSBIN
    export PATH
else
    CSBIN_DEBUG=$CSBIN_TOP:${CSHOME}/bin/${CSOS}_debug
    CSBIN_OPTIMIZED=$CSBIN_TOP:${CSHOME}/bin/${CSOS}_optimized

    PATH_TEMP=$PATH
    PATH_ALREADY=`echo $PATH|egrep "($CSBIN_DEBUG|$CSBIN_OPTIMIZED)"`
    if [ -z "$PATH_ALREADY" ];
    then
        PATH_TEMP=$CSBIN:$PATH_TEMP
    else
	PATH_TEMP=`echo $PATH_TEMP | sed "s,$CSBIN_DEBUG,$CSBIN,g" | sed "s,$CSBIN_OPTIMIZED,$CSBIN,g"`
    fi
    PATH=$CSBIN_TOP:$PATH_TEMP
    export PATH
    unset PATH_TEMP PATH_ALREADY CSBIN_DEBUG CSBIN_OPTIMIZED CSBIN_TOP
fi

## export vars
export CSHOME CSLIB CSBIN CSTARGET CSOS




