###############################################################################
#                                                                             #
# Copyright 1999 INTERSOLV Inc. All rights reserved                           #
#                                                                             #
# Purpose:    Make file to build SequeLink example application                #
#                                                                             #
# Requirements:                                                               #
#                                                                             #
# Shared Library Path Variable:                                               #
# Environment variable should point to the lib directory                      #
# for this release. This will enable the linker to resolve the                #
# location of the various shared libraries and the run-time linker to         #
# resolve the location of run-time components.                                #
#                                                                             #
# To Build example, issue the following command:                              #
# %make -f example.mak                                                        #
#                                                                             #
###############################################################################

CC=gcc

#
# Compiler options
#
CCFLAGS=-w -g
DEFS=-DODBCVER=0x0250 
INCLUDE=-I../include

#
# Definition for standard system linker
#
LD=ld

#
# Define Support Libraries used.
#
LIBPATH=-L../lib
LIBC=-lc
LIBS=$(LIBPATH) -lodbc

#
# Application that shows a single C source code connecting to different
# vendor databases by simply changing the passed in DSN.
#
#
# Sample program using C Compiler
#
example:	example.c
	$(CC) -o example $(DEFS) $(CCFLAGS) $(INCLUDE) example.c $(LIBS) $(LIBC)

clean:
	/bin/rm example
#
# End of Makefile
#
